import gleam/dynamic/decode.{type Decoder}
import spacetraders_models/meta.{type Meta}

pub type PagedData(data) {
  PagedData(data: data, meta: Meta)
}

pub fn decoder(data_decoder: Decoder(data)) -> Decoder(PagedData(data)) {
  use data <- decode.field("data", data_decoder)
  use meta <- decode.field("meta", meta.decoder())
  decode.success(PagedData(data:, meta:))
}
